using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Input.Touch;
using Microsoft.Xna.Framework.Media;

namespace CheeseRoller
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class CheeseRollerGame : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // Game World

        Texture2D cheeseTexture;
        Rectangle cheeseDrawPosition;
        Vector2 cheeseSpeed;


        //Run the program and show that it is now geared for portrait.

        //Edit the constructor and change the preferred size to:

        // graphics.PreferredBackBufferWidth = 240;
        // graphics.PreferredBackBufferHeight = 400;

        //Run the program again and note that the display looks the same. 
        //Make the point that it looks OK, but it is now using a quarter of the memory for the screen.

        //Change again to:

        // graphics.PreferredBackBufferWidth = 240;
        // graphics.PreferredBackBufferHeight = 240;

        //Show that the display is now square, the hardware scaling has put black bands round the top and bottom of the screen.

        public CheeseRollerGame()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            // Frame rate is 30 fps by default for Windows Phone.
            TargetElapsedTime = TimeSpan.FromTicks(333333);

            // Tell XNA we can only support Portrait orientation
            // Can support a range of orientations by ORing 
            // together orientation values
            graphics.SupportedOrientations = DisplayOrientation.Portrait;

            // Set up hardware scaling of the display area
            graphics.PreferredBackBufferWidth = 480;
            graphics.PreferredBackBufferHeight = 800;
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {


            // Create the draw rectangle 
            // Cheese should be a 12th the size of the screen
            cheeseDrawPosition = new Rectangle(
                0, 0, // top left hand corner of the screen
                GraphicsDevice.Viewport.Width / 12, // width
                GraphicsDevice.Viewport.Width / 12  // height
                );

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            cheeseTexture = Content.Load<Texture2D>("Edam");
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();

            spriteBatch.Draw(cheeseTexture, cheeseDrawPosition, Color.White);

            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
